<?php

// ensure this file is being included by a parent file
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

$_MAMBOTS->registerFunction( 'onSendPMS', 'botUddeIM_sendUserPMS' );

function botUddeIM_pmsUddeGetTime($currentTime) {
	global $mosConfig_offset;
	return $currentTime+($mosConfig_offset*3600);
}
	
function botUddeIM_sendPMSuddesysMSG($udde_toid,$udde_fromid,$to,$from,$sub,$msg) {
	global $database, $mainframe; 
	
	if(file_exists( $mainframe->getCfg('absolute_path') . "/administrator/components/com_uddeim/config.class.php"))
		include_once( $mainframe->getCfg('absolute_path') . "/administrator/components/com_uddeim/config.class.php");
	$config = new uddeimconfigclass();

	$udde_sysm = "System";
	if($config->sysm_username) {
		$udde_sysm = $config->sysm_username;		
	}

	// format the message
	if($sub) {
		$udde_msg = "[b]".$sub."[/b]\n\n".$msg;
	} else {
		$udde_msg = $msg;
	}
	
	// now change the <strong> or <b> tags to BB Code
	$udde_msg = str_replace("<strong>","[b]",$udde_msg);
	$udde_msg = str_replace("<b>","[b]",$udde_msg);
	$udde_msg = str_replace("</strong>","[/b]",$udde_msg);
	$udde_msg = str_replace("</b>","[/b]",$udde_msg);

	// now change the links to BB code links
	$udde_msg = str_replace("<a href=\"", "[url=", $udde_msg);
	$udde_msg = str_replace("<a href=\\\"", "[url=", $udde_msg);		
	$udde_msg = str_replace("\">", "]", $udde_msg);
	$udde_msg = str_replace("\\\">", "]", $udde_msg);		
	$udde_msg = str_replace("</a>", "[/url]", $udde_msg);
	$udde_msg = str_replace("<br/>", "\n", $udde_msg);
	$udde_msg = str_replace("<br />", "\n", $udde_msg);
	$udde_msg = str_replace("<br>", "\n", $udde_msg);
	$udde_msg = str_replace("&amp;", "&", $udde_msg);
		
	// workaround
	// commands above made the closing bracket of the div to a ]
	// we change it back to a > here so that the next command can strip the div entirely
	$udde_msg = str_replace("cbNotice\\\"]", "cbNotice\\\">", $udde_msg);
	$udde_msg = str_replace("cbNotice]", "cbNotice\">", $udde_msg);
	$udde_msg = str_replace("cbNotice\\]", "cbNotice\">", $udde_msg);
		
	// now strip the remaining html tags
	$udde_msg = strip_tags($udde_msg);
		
	// get current time but recognize mosConfig Offset
	$currentTime=time();
	$udde_time=botUddeIM_pmsUddeGetTime($currentTime);
	
	// set the udde systemmessage username to the virtual sender
	$udde_sysm=$from;
	
	// try to find the realnames settings of udde
	if($config->realnames) {
		$sql="SELECT name FROM #__users WHERE id=".(int) $udde_fromid;
		$database->setQuery($sql);
		$quereply=$database->loadResult();
		if($quereply) {
			$udde_sysm=$quereply;
		}
	}
	
	$cm = $udde_msg;
	$sql="INSERT INTO #__uddeim (fromid, toid, message, datum, systemmessage, disablereply) VALUES (".$udde_fromid.", ".$udde_toid.", '".$cm."', ".$udde_time.", '".$udde_sysm."', 0)";

	// escaping not necessary, already escaped before this internal function gets called now insert the message as system message 
	// REPLY IS NOT DISABLED AS THE SYSTEMMESSAGE USERNAME WILL CONTAIN A VALID USERNAME
	if($udde_fromid && $udde_toid) {
		$database->SetQuery($sql);
		if (!$database->query()) {
			die("SQL error" . $database->stderr(true));
		}
	}
		
	// E-Mail notification code
	botUddeIM_pmsUddeNotify($udde_fromid, $udde_toid, $udde_msg, $udde_sysm);
}

function botUddeIM_sendPMSuddeimMSG($udde_toid,$udde_fromid,$to,$from,$sub,$msg) {
	global $database, $mainframe; 
	
	if(file_exists( $mainframe->getCfg('absolute_path') . "/administrator/components/com_uddeim/config.class.php"))
		include_once( $mainframe->getCfg('absolute_path') . "/administrator/components/com_uddeim/config.class.php");
	$config = new uddeimconfigclass();

	$udde_sysm = "System";
	if($config->sysm_username) {
		$udde_sysm = $config->sysm_username;		
	}

	// format the message
	if($sub) { // is actually impossible
		$udde_msg = "[b]".$sub."[/b]\n\n".$msg;
	} else {
		$udde_msg = $msg;
	}
		
	// now strip the remaining html tags
	$udde_msg = strip_tags($udde_msg);
		
	// escape dangerous stuff
	// not necessary, already escaped before this internal function gets called
		
	// get current time but recognize mosConfig Offset
	$currentTime=time();
	$udde_time=botUddeIM_pmsUddeGetTime($currentTime);
		
	// set the udde systemmessage username to the virtual sender
	$udde_sysm=$from;

	$cm = $udde_msg;
	$sql="INSERT INTO #__uddeim (fromid, toid, message, datum) VALUES (".$udde_fromid.", ".$udde_toid.", '".$cm."', ".$udde_time.")";

	if($udde_fromid && $udde_toid) {
		$database->SetQuery($sql);
		if (!$database->query()) {
			die("SQL error" . $database->stderr(true));
		}
	}

	// E-Mail notification code
	botUddeIM_pmsUddeNotify($udde_fromid, $udde_toid, $udde_msg, $udde_sysm);
}

function botUddeIM_sendUserPMS( $toid, $fromid, $subject, $message ) 
{	global $database,$mosConfig_absolute_path;
	
	if(file_exists( $mainframe->getCfg('absolute_path') . "/administrator/components/com_uddeim/config.class.php"))
		include_once( $mainframe->getCfg('absolute_path') . "/administrator/components/com_uddeim/config.class.php");
	$config = new uddeimconfigclass();

	$toid	= (int) $toid;
	$fromid	= (int) $fromid;
	if (!$escaped) {
		$subject = $database->getEscaped($subject);
		$message = $database->getEscaped($message);
	}

	if ($fromid) {
		$rowFrom = new mosUser( $database );
		$rowFrom->load( (int) $fromid );
		$from = $rowFrom->username;
	} else {
		$from = null;
	}
		
	$rowTo = new mosUser( $database );
	$rowTo->load( (int) $toid );	
	$to=$rowTo->username;
		
	if($systemGenerated || !$fromid) {
		botUddeIM_sendPMSuddesysMSG($toid,$fromid,$to,$from,$subject,$message);
	} else {
		botUddeIM_sendPMSuddeimMSG($toid,$fromid,$to,$from,$subject,$message);				
	}
	return true;
} 

function botUddeIM_pmsUddeNotify ($savefromid, $savetoid, $savemessage, $udde_sysm) {
	global $database, $mainframe;
		
	if(file_exists( $mainframe->getCfg('absolute_path') . "/administrator/components/com_uddeim/config.class.php"))
		include_once( $mainframe->getCfg('absolute_path') . "/administrator/components/com_uddeim/config.class.php");
	$config = new uddeimconfigclass();

	if ($config->notifydefault>0 || $config->popupdefault>0) {
		$sql="SELECT count(id) FROM #__uddeim_emn WHERE userid=".(int)$savetoid;
		$database->setQuery($sql);
		$entryexists=$database->loadResult();
		if (!$entryexists) {
			$sql="INSERT INTO #__uddeim_emn (status, popup, userid) VALUES (".(int)$config->notifydefault.", ".(int)$config->popupdefault.", ".(int)$savetoid.")";
			$database->setQuery($sql);
			$ret=$database->query();
		}
	}

	$itisareply = (isset($config->quotedivider) ? stristr($savemessage, $config->quotedivider) : false);

	$sql="SELECT userid FROM #__session WHERE userid=".(int) $savetoid;
	$database->setQuery($sql);
	$currentlyonline=$database->loadResult();
		
	if ($config->allowemailnotify==1) {
		$sql="SELECT status FROM #__uddeim_emn WHERE userid=".(int) $savetoid;
		$database->setQuery($sql);
		$ison=$database->loadResult();
		if (($ison==1) || ($ison==2 && !$currentlyonline) || ($ison==10 && !$itisareply) || ($ison==20 && !$currentlyonline && !$itisareply))  {
			botUddeIM_pmsUddeDispatchEMN($savefromid, $savetoid, $savemessage, 0, $udde_sysm); // 0 stands for normal (not forgetmenot)
		}
	} elseif ($config->allowemailnotify==2) {
		$sql="SELECT gid FROM #__users WHERE id=".(int) $savetoid;
		$database->setQuery($sql);
		$my_gid=$database->loadResult();
		if ($my_gid==24||$my_gid==25) {
			$sql="SELECT status FROM #__uddeim_emn WHERE userid=".(int) $savetoid;
			$database->setQuery($sql);
			$ison=$database->loadResult();
			if (($ison==1) || ($ison==2 && !$currentlyonline) || ($ison==10 && !$itisareply) || ($ison==20 && !$currentlyonline && !$itisareply))  {
				botUddeIM_pmsUddeDispatchEMN($savefromid, $savetoid, $savemessage, 0, $udde_sysm);  // 0 stands for normal (not forgetmenot)
			} 	
		}	
	}
}
	
function botUddeIM_pmsUddeDispatchEMN($var_fromid, $var_toid, $var_message, $emn_option, $udde_sysm) {
	global $database, $mosConfig_lang, $mosConfig_sitename, $mainframe;
		
	if(file_exists( $mainframe->getCfg('absolute_path') . "/administrator/components/com_uddeim/config.class.php"))
		include_once( $mainframe->getCfg('absolute_path') . "/administrator/components/com_uddeim/config.class.php");
	$config = new uddeimconfigclass();

	$adminpath = $mainframe->getCfg('absolute_path') . "/administrator/components/com_uddeim";

	// load the uddeim lang file		
	$postfix = "";
	if ($config->languagecharset)
		$postfix = ".utf8";
	if (file_exists($adminpath.'/language'.$postfix.'/'.$mosConfig_lang.'.php')) {
		include_once($adminpath.'/language'.$postfix.'/'.$mosConfig_lang.'.php');
	} elseif (file_exists($adminpath.'/language'.$postfix.'/english.php')) {
		include_once($adminpath.'/language'.$postfix.'/english.php');
	} elseif (file_exists($adminpath.'/language/english.php')) {
		include_once($adminpath.'/language/english.php');
	}

	// if e-mail traffic stopped, don't send.
	if (isset($config->emailtrafficenabled) && !($config->emailtrafficenabled > 0)) {
		return;
	}
		
	$sql = "SELECT ".($config->realnames ? "name" : "username")." FROM #__users WHERE `id`=".(int) $var_fromid;
	$database->setQuery($sql);
	$var_fromname=$database->loadResult();
	if (!$var_fromname) {
		$var_fromname=$config->sysm_username;
	}
		
	$sql = "SELECT ".($config->realnames ? "name" : "username")." AS displayname, email FROM #__users WHERE `id`=".(int) $var_toid;	
	$database->setQuery($sql);
	$results=$database->loadObjectList();
	foreach ($results as $result) {
		$var_toname = $result->displayname;
		$var_tomail = $result->email;
	}
		
	if (!$var_tomail) {
		return;
	}
		
	if ($emn_option==1) {
		$var_body = _UDDEIM_EMN_FORGETMENOT;
		$var_body = str_replace("%you%", $var_toname, $var_body);
		$var_body = str_replace("%site%", $mosConfig_sitename, $var_body);
	} else {
		if ($config->emailwithmessage) {
			$var_body = _UDDEIM_EMN_BODY_WITHMESSAGE;
			$var_body = str_replace("%you%", $var_toname, $var_body);
			$var_body = str_replace("%site%", $mosConfig_sitename, $var_body);	
			$var_body = str_replace("%user%", $var_fromname, $var_body);
			$var_body = str_replace("%pmessage%", $var_message, $var_body);	
		} else {
			$var_body=_UDDEIM_EMN_BODY_NOMESSAGE;
			$var_body = str_replace("%you%", $var_toname, $var_body);
			$var_body = str_replace("%site%", $mosConfig_sitename, $var_body);		
			$var_body = str_replace("%user%", $var_fromname, $var_body);			
		}
	}
	
	$subject=_UDDEIM_EMN_SUBJECT;
	$subject=str_replace("%site%", $mosConfig_sitename, $subject);
		
	if (mosMail($config->emn_sendermail, $config->emn_sendername, $var_tomail,$subject,botUddeIM_pmsMailcompatible($var_body))) {
		// set the remindersent status of this user to true
		$sql="SELECT count(id) FROM #__uddeim_emn WHERE userid=".(int) $var_toid;
		$database->setQuery($sql);
		$exists=$database->loadResult();
		if($exists) {
			$sql="UPDATE #__uddeim_emn SET remindersent=".(int) botUddeIM_pmsUddeGetTime(time())." WHERE userid=".(int) $var_toid;
			$database->setQuery($sql);
			if (!$database->query()) {
				die("SQL error" . $database->stderr(true));
			}
		} else {
			$sql="INSERT INTO #__uddeim_emn (userid, status, remindersent) VALUES (".(int) $var_toid.", 0, ".(int) botUddeIM_pmsUddeGetTime(time()).")";
			$database->setQuery($sql);
			if (!$database->query()) {
				die("SQL error" . $database->stderr(true));
			} // end if database query
		} // end else
	} // end if mail
} // end function

function botUddeIM_pmsMailcompatible($string) {
	$string = str_replace('\\n', '#!CRLF!#', $string);
	$string = stripslashes($string);
	$string = preg_replace("/(\[b\])(.*?)(\[\/b\])/si","\\2",$string);
	$string = preg_replace("/(\[u\])(.*?)(\[\/u\])/si","\\2",$string);
	$string = preg_replace("/(\[i\])(.*?)(\[\/i\])/si","\\2",$string);
	$string = preg_replace("/\[size=([1-7])\](.+?)\[\/size\]/si","\\2",$string);
	$string = preg_replace("%\[color=(.*?)\](.*?)\[/color\]%si","\\2",$string);
	$string = preg_replace("/(\[ul\])(.*?)(\[\/ul\])/si","\\2",$string);
	$string = preg_replace("/(\[ol\])(.*?)(\[\/ol\])/si","\\2",$string);
	$string = preg_replace("/(\[li\])(.*?)(\[\/li\])/si","\\2\\n",$string);
	$string = preg_replace('/\[url\](.*?)javascript(.*?)\[\/url\]/si','',$string);
	$string = preg_replace('/\[url=(.*?)javascript(.*?)\](.*?)\[\/url\]/si','',$string);
	$string = preg_replace("/\[url\](.*?)\[\/url\]/si","\\1",$string);
	$string = preg_replace("/\[url=(.*?)\](.*?)\[\/url\]/si","\\2 (\\1)",$string);	
	$string = preg_replace("/\[url=(.*?)\]/si","",$string);	
	$string = preg_replace("/\[img size=([0-9][0-9][0-9])\](.*?)\[\/img\]/si","",$string);
	$string = preg_replace("/\[img size=([0-9][0-9])\](.*?)\[\/img\]/si","",$string);
	$string = preg_replace("/\[img\](.*?)\[\/img\]/si","",$string);
	$string = preg_replace("/<img(.*?)javascript(.*?)>/si",'',$string);	
	$string = preg_replace("/\[img size=([0-9][0-9][0-9])\]]/si","",$string);
	$string = preg_replace("/\[img size=([0-9][0-9])\]]/si","",$string);
	$string = str_replace(array("[i]","[/i]","[b]","[/b]","[u]","[/u]","[ul]","[/ul]","[ol]","[/ol]","[li]","[/li]"), "", $string);
	$string = preg_replace('/\[url=(.*?)javascript(.*?)\]/si','',$string);	
	$string = preg_replace("/\[img size=([0-9][0-9][0-9])\]/si","",$string);
	$string = preg_replace("/\[img size=([0-9][0-9])\]/si","",$string);
	$string = preg_replace("/\[size=([1-7])\]/si","",$string);
	$string = preg_replace("%\[color=(.*?)\]%si","",$string);
	$string = str_replace(array("[img]","[/img]","[url]","[/url]","[/color]","[/size]"), "", $string);
	$string = str_replace("#!CRLF!#", "\n", $string);	 
	return $string;
}
